      subroutine rk4am(y,t,dy,dt,etol,emintol,neq,flux,nflux) 
      implicit double precision (a-h,o-z) 
      dimension y(neq),dy(neq) 
      dimension ak1(neq),ak2(neq),ak3(neq),ak4(neq),ak5(neq) 
      dimension z4(neq),z5(neq) 
      dimension flux(nflux) 
 
      kstop = neq 
    1 error = 0.0 
      errtmp = 0.0 
      call fcn(y,t,dy,dt,neq,flux,nflux) 
      do n=1,neq 
         ak1(n) = dt*dy(n) 
         z4(n) = y(n) + ak1(n)/3.0 
      enddo 
 
      tnew = t+dt/3.0 
      call fcn(z4,tnew,dy,dt,neq,flux,nflux) 
 
      do n=1,neq 
         ak2(n) = dt*dy(n) 
         z4(n) = y(n) + (ak1(n)+ak2(n))/6.0 
      enddo 
 
      tnew = t+dt/3.0 
      call fcn(z4,tnew,dy,dt,neq,flux,nflux) 
 
      do n=1,neq 
         ak3(n) = dt*dy(n) 
         z4(n) = y(n) + (ak1(n)+3.0*ak3(n))/8.0 
      enddo 
 
      tnew = t + dt/2.0 
      call fcn(z4,tnew,dy,dt,neq,flux,nflux) 
    
      do n=1,neq 
         ak4(n) = dt*dy(n) 
         z4(n) = y(n) + (ak1(n)-3.0*ak3(n)+4.0*ak4(n))/2.0 
      enddo 
 
      tnew = t + dt 
      call fcn(z4,tnew,dy,dt,neq,flux,nflux) 
    
      do n=1,neq 
         ak5(n) = dt*dy(n) 
         z5(n) = y(n) + (ak1(n)+4.0*ak4(n)+ak5(n))/6.0 
 
         errtmp = (errtmp + dabs(z4(n)-z5(n))/5.0)/dfloat(neq) 
      enddo 
 
      error = max(errtmp,error) 
      errtmp = 0.0 
 
  100 continue 
      goto 200 
 
c      if (error.lt.etol.and.error.gt.emintol) then 
c      if (error.lt.etol) then 
c          do k=1,kstop 
c	     y(k)=z5(k) 
c          enddo 
c	  if (error.le.emintol) then 
c             do k=1,kstop 
c	        y(k)=z5(k) 
c             enddo 
c	     dt = 2.0*dt 
c          endif 
c      else 
c	 dt = 0.8*dt*abs(etol/error)**0.02 
c	 goto 1 
c      endif 
 
  200 do k=1,kstop 
	 y(k)=z5(k) 
      enddo 
c      write (6,*) 'error=',error,'dt=',dt 
    
      return 
      end 
